searchNodes=[{"doc":"Some ExUnit assertions","ref":"Moar.Assertions.html","title":"Moar.Assertions","type":"module"},{"doc":"Asserts that the left and right values are equal. Returns the left value unless the assertion fails, or if the :returning option is used. Uses assert left == right under the hood, but works nicely in a pipeline. Options: ignore_order: boolean - if the left and right values are lists, ignores the order when checking equality. returning: value - returns value if the assertion passes, rather than returning the left value. within: delta - asserts that the left and right values are within delta of each other rather than strictly equal. within: {delta, time_unit} - like within: delta but performs time comparisons in the specified time_unit . If left and right are strings, they are parsed as ISO8601 dates.","ref":"Moar.Assertions.html#assert_eq/3","title":"Moar.Assertions.assert_eq/3","type":"function"},{"doc":"Asserts that a pre-condition and a post-condition are true after performing an action. Examples { :ok , agent } = Agent . start ( fn -&gt; 0 end ) assert_that ( Agent . update ( agent , fn s -&gt; s + 1 end ) , changes : Agent . get ( agent , fn s -&gt; s end ) , from : 0 , to : 1 )","ref":"Moar.Assertions.html#assert_that/2","title":"Moar.Assertions.assert_that/2","type":"macro"},{"doc":"","ref":"Moar.Assertions.html#t:assert_eq_opts/0","title":"Moar.Assertions.assert_eq_opts/0","type":"type"},{"doc":"Atom-related functions","ref":"Moar.Atom.html","title":"Moar.Atom","type":"module"},{"doc":"When given a string, converts it to an atom via String.to_atom/1 . When given an atom, returns it unchanged. Useful when you aren't sure ahead of time whether you have a string or an atom and want an atom.","ref":"Moar.Atom.html#from_string/1","title":"Moar.Atom.from_string/1","type":"function"},{"doc":"When given an atom, converts it to a string via Atom.to_string/1 . When given a string, returns it unchanged. Useful when you aren't sure ahead of time whether you have a string or an atom and want a string.","ref":"Moar.Atom.html#to_string/1","title":"Moar.Atom.to_string/1","type":"function"},{"doc":"DateTime-related functions","ref":"Moar.DateTime.html","title":"Moar.DateTime","type":"module"},{"doc":"Like DateTime.from_iso8601/1 but raises if the string cannot be parsed.","ref":"Moar.DateTime.html#from_iso8601!/1","title":"Moar.DateTime.from_iso8601!/1","type":"function"},{"doc":"Like DateTime.to_iso8601/1 but rounds to the nearest second first.","ref":"Moar.DateTime.html#to_iso8601_rounded/1","title":"Moar.DateTime.to_iso8601_rounded/1","type":"function"},{"doc":"A protocol that defines diff/2 for finding the difference between two terms. Includes implementations for DateTime , NaiveDateTime , and BitString .","ref":"Moar.Difference.html","title":"Moar.Difference","type":"protocol"},{"doc":"Returns the difference between a and b . The fallback implementation uses Kernel.-/2 to subtract b from a .","ref":"Moar.Difference.html#diff/2","title":"Moar.Difference.diff/2","type":"function"},{"doc":"","ref":"Moar.Difference.html#t:t/0","title":"Moar.Difference.t/0","type":"type"},{"doc":"A duration is a {time, unit} tuple, where the time is a number and the unit is one of: :nanosecond , :microsecond , :millisecond , :second , :minute , :hour , :day","ref":"Moar.Duration.html","title":"Moar.Duration","type":"module"},{"doc":"Converts a {duration, time_unit} tuple into a numeric duration. Rounds down to the nearest whole number. Uses System.convert_time_unit/3 under the hood; see its documentation for more details. Examples iex&gt; Moar.Duration . convert ( { 121 , :second } , :minute ) 2","ref":"Moar.Duration.html#convert/2","title":"Moar.Duration.convert/2","type":"function"},{"doc":"Converts a {duration, time_unit} tuple into a string. Examples iex&gt; Moar.Duration . to_string ( { 1 , :second } ) &quot;1 second&quot; iex&gt; Moar.Duration . to_string ( { 25 , :millisecond } ) &quot;25 milliseconds&quot;","ref":"Moar.Duration.html#to_string/1","title":"Moar.Duration.to_string/1","type":"function"},{"doc":"","ref":"Moar.Duration.html#t:duration/0","title":"Moar.Duration.duration/0","type":"type"},{"doc":"","ref":"Moar.Duration.html#t:time_unit/0","title":"Moar.Duration.time_unit/0","type":"type"},{"doc":"Enum-related functions","ref":"Moar.Enum.html","title":"Moar.Enum","type":"module"},{"doc":"Like Enum.at/2 but raises if index is out of bounds","ref":"Moar.Enum.html#at!/2","title":"Moar.Enum.at!/2","type":"function"},{"doc":"Removes nil elements from enum","ref":"Moar.Enum.html#compact/1","title":"Moar.Enum.compact/1","type":"function"},{"doc":"Returns the first item of enum , or raises if it is empty","ref":"Moar.Enum.html#first!/1","title":"Moar.Enum.first!/1","type":"function"},{"doc":"Sort enum case-insensitively","ref":"Moar.Enum.html#isort/1","title":"Moar.Enum.isort/1","type":"function"},{"doc":"Sort enum case-insensitively by mapper function","ref":"Moar.Enum.html#isort_by/2","title":"Moar.Enum.isort_by/2","type":"function"},{"doc":"Return :tid fields from enumerable","ref":"Moar.Enum.html#tids/1","title":"Moar.Enum.tids/1","type":"function"},{"doc":"File-related functions","ref":"Moar.File.html","title":"Moar.File","type":"module"},{"doc":"Returns a path to a new temp file in a new temp directory.","ref":"Moar.File.html#new_tempfile_path/1","title":"Moar.File.new_tempfile_path/1","type":"function"},{"doc":"Writes contents to a new temp file with extension file_extension , and returns the path to the file.","ref":"Moar.File.html#write_tempfile/2","title":"Moar.File.write_tempfile/2","type":"function"},{"doc":"Map-related functions","ref":"Moar.Map.html","title":"Moar.Map","type":"module"},{"doc":"Convert keys in map to atoms","ref":"Moar.Map.html#atomize_keys/1","title":"Moar.Map.atomize_keys/1","type":"function"},{"doc":"Convert keys to atoms, traversing through descendant lists and maps","ref":"Moar.Map.html#deep_atomize_keys/1","title":"Moar.Map.deep_atomize_keys/1","type":"function"},{"doc":"Merge two enumerables into a single map","ref":"Moar.Map.html#merge/2","title":"Moar.Map.merge/2","type":"function"},{"doc":"","ref":"Moar.Map.html#rename_key/2","title":"Moar.Map.rename_key/2","type":"function"},{"doc":"Return a copy of map with old_key_name changed to new_key_name","ref":"Moar.Map.html#rename_key/3","title":"Moar.Map.rename_key/3","type":"function"},{"doc":"","ref":"Moar.Map.html#rename_keys/2","title":"Moar.Map.rename_keys/2","type":"function"},{"doc":"Convert keys in map to strings","ref":"Moar.Map.html#stringify_keys/1","title":"Moar.Map.stringify_keys/1","type":"function"},{"doc":"Transform values of map using transformer function","ref":"Moar.Map.html#transform/3","title":"Moar.Map.transform/3","type":"function"},{"doc":"","ref":"Moar.Protocol.html","title":"Moar.Protocol","type":"module"},{"doc":"Returns x or raises if x does not implment protocol","ref":"Moar.Protocol.html#implements!/2","title":"Moar.Protocol.implements!/2","type":"function"},{"doc":"Generate random data.","ref":"Moar.Random.html","title":"Moar.Random","type":"module"},{"doc":"Returns a random integer between 0 and max","ref":"Moar.Random.html#integer/1","title":"Moar.Random.integer/1","type":"function"},{"doc":"Returns a base64- or base32-encoded random string of 32 characters. See Moar.Random.string/2 .","ref":"Moar.Random.html#string/1","title":"Moar.Random.string/1","type":"function"},{"doc":"Returns a base64- or base32-encoded random string of given length iex&gt; Moar.Random . string ( ) &quot;Sr/y4m/YiVSJcIgI5lG+76vMfaZ7KZ7c&quot; iex&gt; Moar.Random . string ( 5 ) &quot;9pJrK&quot; iex&gt; Moar.Random . string ( 5 , :base32 ) &quot;AC53Z&quot;","ref":"Moar.Random.html#string/2","title":"Moar.Random.string/2","type":"function"},{"doc":"","ref":"Moar.Random.html#t:encoding/0","title":"Moar.Random.encoding/0","type":"type"},{"doc":"String-related functions","ref":"Moar.String.html","title":"Moar.String","type":"module"},{"doc":"Convert strings and atoms to dash-case (kebab-case) and trims leading and trailing non-alphanumeric characters. The following all get converted to &quot;foo&quot; : &quot;foo&quot; , &quot;FOO&quot; , :foo . The following all get converted to &quot;foo-bar&quot; : &quot;foo-bar&quot; , :foo_bar , &quot; fooBar &quot; , &quot; ?foo ! bar &quot;","ref":"Moar.String.html#dasherize/1","title":"Moar.String.dasherize/1","type":"function"},{"doc":"Truncate s to max_length by removing the middle of the string","ref":"Moar.String.html#inner_truncate/2","title":"Moar.String.inner_truncate/2","type":"function"},{"doc":"Compares the two binaries in constant-time to avoid timing attacks. See: http://codahale.com/a-lesson-in-timing-attacks/","ref":"Moar.String.html#secure_compare/2","title":"Moar.String.secure_compare/2","type":"function"},{"doc":"Replace consecutive whitespace characters with a single space","ref":"Moar.String.html#squish/1","title":"Moar.String.squish/1","type":"function"},{"doc":"Add surrounder to the beginning and end of s","ref":"Moar.String.html#surround/2","title":"Moar.String.surround/2","type":"function"},{"doc":"Add prefix to the beginning of s and suffix to the end","ref":"Moar.String.html#surround/3","title":"Moar.String.surround/3","type":"function"},{"doc":"Convert a string to an integer. Returns nil if the argument is nil or empty string","ref":"Moar.String.html#to_integer/1","title":"Moar.String.to_integer/1","type":"function"},{"doc":"Like to_integer/1 but with options: :lenient option removes non-digit characters first default: option specifies a default in case s is nil","ref":"Moar.String.html#to_integer/2","title":"Moar.String.to_integer/2","type":"function"},{"doc":"Like String.trim/1 but returns nil if the argument is nil","ref":"Moar.String.html#trim/1","title":"Moar.String.trim/1","type":"function"},{"doc":"Truncates s at the last instance of at , causing the string to be at most limit characters. iex&gt; Moar.String . truncate_at ( &quot;I like apples. I like bananas. I like cherries.&quot; , &quot;.&quot; , 35 ) &quot;I like apples. I like bananas.&quot;","ref":"Moar.String.html#truncate_at/3","title":"Moar.String.truncate_at/3","type":"function"},{"doc":"Some common syntactic sugar functions. These functions are intended to be used by importing the functions or the whole module: import Moar.Sugar , only : [ noreply : 1 ] def handle_event ( &quot;foo&quot; , _params , socket ) do socket |&gt; assign ( foo : &quot;bar&quot; ) |&gt; noreply ( ) end","ref":"Moar.Sugar.html","title":"Moar.Sugar","type":"module"},{"doc":"Unwraps an :error tuple, raising if the term is not an :error tuple iex&gt; { :error , 1 } |&gt; Moar.Sugar . error! ( ) 1","ref":"Moar.Sugar.html#error!/1","title":"Moar.Sugar.error!/1","type":"function"},{"doc":"Wraps a term in an :error tuple. Useful in pipelines. iex&gt; %{ } |&gt; Map . put ( :count , &quot;unknown&quot; ) |&gt; Moar.Sugar . error ( ) { :error , %{ count : &quot;unknown&quot; } }","ref":"Moar.Sugar.html#error/1","title":"Moar.Sugar.error/1","type":"function"},{"doc":"Wraps a term in a :noreply tuple iex&gt; %{ } |&gt; Map . put ( :count , 0 ) |&gt; Moar.Sugar . noreply ( ) { :noreply , %{ count : 0 } }","ref":"Moar.Sugar.html#noreply/1","title":"Moar.Sugar.noreply/1","type":"function"},{"doc":"Unwraps an :ok tuple, raising if the term is not an :ok tuple iex&gt; { :ok , 1 } |&gt; Moar.Sugar . ok! ( ) 1","ref":"Moar.Sugar.html#ok!/1","title":"Moar.Sugar.ok!/1","type":"function"},{"doc":"Wraps a term in an :ok tuple iex&gt; %{ } |&gt; Map . put ( :count , 10 ) |&gt; Moar.Sugar . ok ( ) { :ok , %{ count : 10 } }","ref":"Moar.Sugar.html#ok/1","title":"Moar.Sugar.ok/1","type":"function"},{"doc":"Accepts two arguments and returns the second. Useful at the end of the pipeline when you want to return a different value than the last result of the pipeline, such as when the pipeline has side effects and you want to return a different value and you feel the code will be easier to read if everything is in a pipeline. iex&gt; %{ } |&gt; Map . put ( :count , 20 ) |&gt; Moar.Sugar . returning ( :count_updated ) :count_updated","ref":"Moar.Sugar.html#returning/2","title":"Moar.Sugar.returning/2","type":"function"},{"doc":"Extra functions for terms.","ref":"Moar.Term.html","title":"Moar.Term","type":"module"},{"doc":"Returns true if the term is blank, nil, or empty","ref":"Moar.Term.html#blank?/1","title":"Moar.Term.blank?/1","type":"function"},{"doc":"Returns value unless it is blank, in which case it returns default","ref":"Moar.Term.html#or_default/2","title":"Moar.Term.or_default/2","type":"function"},{"doc":"Returns the value if it is present (via present? ), or else returns the default value","ref":"Moar.Term.html#presence/2","title":"Moar.Term.presence/2","type":"function"},{"doc":"Returns true if the term is not blank, nil, or empty","ref":"Moar.Term.html#present?/1","title":"Moar.Term.present?/1","type":"function"},{"doc":"A collection of useful functions. The docs can be found at https://hexdocs.pm/moar","ref":"readme.html","title":"Moar","type":"extras"},{"doc":"The package can be installed by adding moar to your list of dependencies in mix.exs : def deps do [ { :moar , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Moar - Installation","type":"extras"},{"doc":"Copyright 2022 synchronal.dev Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]